Agora Java API Reference for Android

Public Member Functions | Public Attributes | List of all members
agora::rtc::ScreenCaptureParameters Struct Reference

Screen sharing configurations. More...

`#include <AgoraBase.h>`

## Public Member Functions
| ScreenCaptureParameters (const VideoDimensions &d, int f, int b)
| ScreenCaptureParameters (int width, int height, int f, int b)
| ScreenCaptureParameters (int width, int height, int f, int b, bool cur, bool fcs)
| ScreenCaptureParameters (int width, int height, int f, int b, view_t *ex, int cnt)
| ScreenCaptureParameters (int width, int height, int f, int b, bool cur, bool fcs, view_t *ex, int cnt)

## Public Attributes
bool | captureAudio
ScreenAudioParameters | audioParams
VideoDimensions | dimensions
int | frameRate
int | bitrate
bool | captureMouseCursor
bool | windowFocus
view_t * | excludeWindowList
int | excludeWindowCount
int | highLightWidth
unsigned int | highLightColor
bool | enableHighLight

## Detailed Description

Screen sharing configurations.

## Member Data Documentation

## ◆ captureAudio

bool agora::rtc::ScreenCaptureParameters::captureAudio

Determines whether to capture system audio during screen sharing:

- `true`: Capture.
- `false`: (Default) Do not capture.

Note
  Due to system limitations, capturing system audio is only available for Android API level 29 and later (that is, Android 10 and later).

## ◆ audioParams

ScreenAudioParameters agora::rtc::ScreenCaptureParameters::audioParams

The audio configuration for the shared screen stream.

Note
  This parameter only takes effect when `captureAudio` is `true`. See `ScreenAudioParameters`.

## ◆ dimensions

VideoDimensions agora::rtc::ScreenCaptureParameters::dimensions

The video encoding resolution of the screen sharing stream. See `VideoDimensions`. The default value is 1920 × 1080, that is, 2,073,600 pixels. Agora uses the value of this parameter to calculate the charges. If the screen dimensions are different from the value of this parameter, Agora applies the following strategies for encoding. Suppose `dimensions` is set to 1920 × 1080:

- If the value of the screen dimensions is lower than that of `dimensions`, for example, 1000 × 1000 pixels, the SDK uses the screen dimensions, that is, 1000 × 1000 pixels, for encoding.
- If the value of the screen dimensions is higher than that of `dimensions`, for example, 2000 × 1500, the SDK uses the maximum value under `dimensions` with the aspect ratio of the screen dimension (4:3) for encoding, that is, 1440 × 1080.
  Note
    When setting the encoding resolution in the scenario of sharing documents ( SCREEN_SCENARIO_DOCUMENT ), choose one of the following two methods:
- If you require the best image quality, it is recommended to set the encoding resolution to be the same as the capture resolution.
- If you wish to achieve a relative balance between image quality, bandwidth, and system performance, then:
  - When the capture resolution is greater than 1920 × 1080, it is recommended that the encoding resolution is not less than 1920 × 1080.
  - When the capture resolution is less than 1920 × 1080, it is recommended that the encoding resolution is not less than 1280 × 720.

## ◆ frameRate

int agora::rtc::ScreenCaptureParameters::frameRate

On Windows and macOS, this represents the video encoding frame rate (fps) of the screen sharing stream. The frame rate (fps) of the shared region. The default value is 5. Agora does not recommend setting this to a value greater than 15.

## ◆ bitrate

int agora::rtc::ScreenCaptureParameters::bitrate

On Windows and macOS, this represents the video encoding bitrate of the screen sharing stream. The bitrate (Kbps) of the shared region. The default value is 0 (the SDK works out a bitrate according to the dimensions of the current screen).

## ◆ captureMouseCursor

bool agora::rtc::ScreenCaptureParameters::captureMouseCursor

Whether to capture the mouse in screen sharing:

- `true`: (Default) Capture the mouse.
- `false`: Do not capture the mouse.
  Note
    Due to macOS system restrictions, setting this parameter to `false` is ineffective during screen sharing (it has no impact when sharing a window).

## ◆ windowFocus

bool agora::rtc::ScreenCaptureParameters::windowFocus

Whether to bring the window to the front when calling the `startScreenCaptureByWindowId` method to share it:

- `true`: Bring the window to the front.
- `false`: (Default) Do not bring the window to the front.
  Note
    Due to macOS system limitations, when setting this member to bring the window to the front, if the current app has multiple windows, only the main window will be brought to the front.

## ◆ excludeWindowList

view_t* agora::rtc::ScreenCaptureParameters::excludeWindowList

The ID list of the windows to be blocked. When calling `startScreenCaptureByDisplayId` to start screen sharing, you can use this parameter to block a specified window. When calling `updateScreenCaptureParameters` to update screen sharing configurations, you can use this parameter to dynamically block a specified window.

## ◆ excludeWindowCount

int agora::rtc::ScreenCaptureParameters::excludeWindowCount

The number of windows to be excluded.

Note
  On the Windows platform, the maximum value of this parameter is 24; if this value is exceeded, excluding the window fails.

## ◆ highLightWidth

int agora::rtc::ScreenCaptureParameters::highLightWidth

(For macOS and Windows only) The width (px) of the border. The default value is 5, and the value range is (0, 50].

Note
  This parameter only takes effect when `highLighted` is set to `true`.

## ◆ highLightColor

unsigned int agora::rtc::ScreenCaptureParameters::highLightColor

(For macOS and Windows only)

- On Windows platforms, the color of the border in ARGB format. The default value is 0xFF8CBF26.
- On macOS, `COLOR_CLASS` refers to `NSColor`.

## ◆ enableHighLight

bool agora::rtc::ScreenCaptureParameters::enableHighLight

(For macOS and Windows only) Whether to place a border around the shared window or screen:

- `true`: Place a border.
- `false`: (Default) Do not place a border.
  Note
    When you share a part of a window or screen, the SDK places a border around the entire window or screen if you set this parameter to `true`.